import { Base, Type, Point } from "igniteui-react-core/ES2015/type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core/ES2015/IFastItemColumn$1";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core/ES2015/Clipper";
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    m2: CategoryFramePreparer;
    protected bf(): SeriesView;
    m6: CategorySeriesView;
    private nf;
    readonly ng: ICategorySeriesInteractionManager;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private n1;
    il(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    mx(): CategoryAxisBase;
    nh(): NumericAxisBase;
    protected get_cl(): boolean;
    constructor();
    ac(): void;
    no: boolean;
    nn: boolean;
    protected nj: boolean;
    protected ni: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected nq(): boolean;
    protected nr(): boolean;
    protected oe(a: AssigningCategoryStyleEventArgs): void;
    protected od(a: AssigningCategoryMarkerStyleEventArgs): void;
    mr(a: number, b: number): any[];
    ho(a: boolean, b: SeriesView): void;
    a8(): SeriesComponentsForView;
    h3(): void;
    nt: boolean;
    protected jk(a: Rect, b: Rect): void;
    m8: CategoryTransitionInMode;
    np: boolean;
    protected jj(a: Rect, b: Rect): void;
    protected ir(a: any, b: string, c: any, d: any): void;
    protected nl(): boolean;
    protected nk(): boolean;
    nw(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    e6(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    fl(a: Point): any;
    e4(a: Point): number;
    d7(a: Point): number;
    private nd;
    private ne;
    protected get_nm(): boolean;
    protected readonly nm: boolean;
    au(a: any, b: Point): HighlightingInfo;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected nv(): List$1<Marker>;
    protected nc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nb(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected na(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    mz: CategoryFrame;
    m1: CategoryFrame;
    my: CategoryFrame;
    m0: CategoryFrame;
    protected m5: CategorySeriesRenderManager;
    protected oa(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected ob(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    du(a: Rect, b: Rect, c: SeriesView): boolean;
    private nu;
    protected da(): boolean;
    protected m7(): CategoryTransitionInMode;
    m9: CategoryTransitionSourceFramePreparer;
    protected hp(): void;
    i5(a: boolean): void;
    protected bo(): TransitionInSpeedType;
    protected nx(): number;
    n0(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    n9(a: CategorySeriesView, b: CategoryFrame): void;
    of(a: CategoryFrame, b: CategorySeriesView): void;
    oc(a: CategoryFrame, b: CategorySeriesView): void;
    ny(a: SeriesView): number;
    nz(a: SeriesView): number;
    n8(a: SeriesView): void;
    i6(a: Rect, b: RenderSurface): void;
    og(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract ns(): boolean;
    m3(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static ms(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    cp: CategorySeries;
    cs: number;
    cr(a: CategoryFrame): boolean;
    cu(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cn: CategoryBucketCalculator;
    co(): CategoryBucketCalculator;
    cq: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    cc(a: (arg1: Marker) => void): void;
    ct(): void;
}
